EDIT - bug #9103

missing exception handling in TaxoNodeDto
06/26/2020 03:31 PM - Andreas Kohlbecker

Status: Closed Start date:
Priority: Highest Due date:
Assignee: Andreas Kohlbecker % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.18
Severity: normal Found in Version:
Description
see
try{

TaxonNode parent = taxonNode.getParent();

parentUUID = parent == null? null:parent.getUuid();

}catch (Exception e) {
parentUUID = null;

sortIndex = taxonNode.getSortIndex();
try{
classificationUUID = taxonNode.getClassification () .getUuid();

}catch (Exception e) {
classificationUUID = null;

LazylInitializationException are caught here, which can lean to missing data due to improper initialization.

Associated revisions

Revision 5d89¢869 - 08/19/2020 11:07 PM - Andreas Kohlbecker
fix #9103 letting LIEs bubble up

Revision b68da265 - 09/07/2020 03:24 PM - Andreas Kohlbecker

ref #9103 adding missing init strategy element to TaxonController

Revision 94959be3 - 11/30/2020 12:09 PM - Andreas Kohlbecker
ref #9103 adding missing null check

Revision 6706afc3 - 11/30/2020 01:17 PM - Katja Luther

ref #9103: add handling of classifications in TaxonnodeDto

Revision da9e29c4 - 11/30/2020 01:39 PM - Katja Luther

ref #9103: add handling of classifications in TaxonnodeDto - continue

History

#1 - 06/26/2020 03:32 PM - Andreas Kohlbecker

@Katja: has far as | could see, this stems from you, was there any urgent reason for this?

#2 - 06/26/2020 03:32 PM - Andreas Kohlbecker

- Status changed from New to Feedback

#3 - 08/17/2020 08:30 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Kohlbecker
sorry, | don't know anymore why | did this.

#4 - 08/17/2020 09:24 PM - Andreas Kohlbecker
- Status changed from Feedback to Resolved
Ok, so we should fix this right after the release by a proper implementation which

1. checks for taxonNode.getClassification() == null and avoids catching exception
2.remove the try .. catch in case of taxonNode.getParent() completely

This should be done quickly after the release to give problems time to pop up!

I'll keep this in the 5.17 milestone as resolved so that it can be done during the milestone cleanup.

#5 - 08/19/2020 08:42 PM - Andreas Miuller

- Target version changed from Release 5.18 to Release 5.17

#6 - 08/19/2020 11:07 PM - Andreas Kohlbecker
- % Done changed from 0 to 50

Applied in changeset cdmlib|5d89c86976dd154266a6eae8c44b3874a2212e2a.

#7 - 08/19/2020 11:08 PM - Andreas Kohlbecker
- Assignee changed from Andreas Kohlbecker to Katja Luther
- Priority changed from New to Highest

- Target version changed from Release 5.17 to Release 5.18

done, please review

#8 - 11/30/2020 11:56 AM - Katja Luther
- Status changed from Resolved to Feedback

- Assignee changed from Katja Luther to Andreas Kohlbecker

the null check for the classification is missing, the rest seems to be correct.

#9 - 11/30/2020 12:13 PM - Andreas Kohlbecker
- Assignee changed from Andreas Kohlbecker to Katja Luther
Katja Luther wrote:
the null check for the classification is missing, the rest seems to be correct.
Good point, there was in deed a missing null check. Not exactly in the code that was affected by my changes, but a couple of lines above. | fixed this.

But this part of the code seems to miss one case. The ITaxonTreeNode taxonTreeNode passed to the constructor can be a Classification. In this case
the tileCache is not set at all. In this case it should be set to the title cache of the classification. Do you agree?

#10 - 11/30/2020 01:06 PM - Katja Luther

Andreas Kohlbecker wrote:
Katja Luther wrote:

the null check for the classification is missing, the rest seems to be correct.

Good point, there was in deed a missing null check. Not exactly in the code that was affected by my changes, but a couple of lines above. | fixed
this. But this part of the code seems to miss one case. The ITaxonTreeNode taxonTreeNode passed to the constructor can be a Classification.
In this case the tileCache is not set at all. In this case it should be set to the title cache of the classification. Do you agree?

Yes you are right this is not covered. | added the missing lines

#11 - 11/30/2020 02:55 PM - Andreas Kohlbecker
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/5d89c86976dd154266a6eae8c44b3874a2212e2a

- Status changed from Feedback to Closed
- Assignee changed from Katja Luther to Andreas Kohlbecker

- % Done changed from 50 to 100

the last commit fixes the potential NPE that was in the code after the previous commit. The code looks ok now and the ticket can be closed.
